<?php

class ForumialSSOClients
{
    protected $db;
    protected $table;
    
    public $id;
    public $client_id;
    public $user_id;
    public $redirect_uri;
    public $expires;
    public $created;
    
	public function __construct() {
		global $wpdb;
        $this->db     = $wpdb;
        $this->table  = $this->db->prefix.'forumial_sso_clients';
    }

	public function get($code) {
		$query = $this->db->prepare("SELECT * from {$this->table} WHERE id = %s", array( $code ));
        $client = $this->db->get_row( $query, ARRAY_A );
        if (!$client) {
            return null;
        }
        return (object) $client;
    }

	public function getAvailable($code) {
		$query = $this->db->prepare("SELECT * from {$this->table} WHERE id = %s", array( $code ));
        $client = $this->db->get_row( $query, ARRAY_A );

        $now = date('Y-m-d H:i:s');
        if (!$client || $client['expires'] < $now) {
            return null;
        }

        return (object) $client;
    }

    public function save()
    {
        $created = date('Y-m-d H:i:s');

        if (empty($this->id)) {
            $this->id = forumial_sso_random_hex(64);
        }

        if (empty($this->expires)) {
            $this->expires = date('Y-m-d H:i:s', strtotime("+1 hours"));
        }

        $query = $this->db->prepare("
            INSERT INTO {$this->table} (
                id, 
                client_id, 
                user_id, 
                redirect_uri, 
                expires, 
                created
            ) VALUES (%s, %s, %s, %s, %s, %s)", array(
                $this->id,
                $this->client_id,
                $this->user_id,
                $this->redirect_uri,
                $this->expires,
                $created
            )
        );

        if ( $this->db->query($query) ) {
            return $this;
        } else {
            return false;
        }
    }

}